#ifndef RJOAC_H
#define RJOAC_H

#include "base.h"
#include "coordinates.h"

#include <random>

namespace motions {
    class RandomJumpOnCone: public BaseMotion {
    public:
        RandomJumpOnCone(double, double, double, std::mt19937_64&);
        explicit RandomJumpOnCone(std::mt19937_64&);

        void initialize() override;

        double jump() override;

        void setParameters(const std::unordered_map<std::string, double> &) override;

        [[nodiscard]] std::unordered_map<std::string, double> getParameters() const override;

        [[nodiscard]] std::string toString() const override;

    private:
        double m_angle{0};
        coordinates::SphericalPos m_axis{1, 0};
    };
}

#endif //RJOAC_H
